    001/* ===========================================================
    002 * Orson Charts : a 3D chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C)opyright 2013-2022, by David Gilbert.  All rights reserved.
    006 *
    007 * https://github.com/jfree/orson-charts
    008 *
    009 * This program is free software: you can redistribute it and/or modify
    010 * it under the terms of the GNU General Public License as published by
    011 * the Free Software Foundation, either version 3 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This program is distributed in the hope that it will be useful,
    015 * but WITHOUT ANY WARRANTY; without even the implied warranty of
    016 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    017 * GNU General Public License for more details.
    018 *
    019 * You should have received a copy of the GNU General Public License
    020 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
    021 *
    022 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    023 * Other names may be trademarks of their respective owners.]
    024 *
    025 * If you do not wish to be bound by the terms of the GPL, an alternative
    026 * commercial license can be purchased.  For details, please see visit the
    027 * Orson Charts home page:
    028 *
    029 * http://www.object-refinery.com/orsoncharts/index.html
    030 *
    031 */
    032
    033package org.jfree.chart3d.plot;
    034
    035import java.util.EventObject;
    036
    037import org.jfree.chart3d.Chart3D;
    038import org.jfree.chart3d.data.Dataset3DChangeEvent;
    039import org.jfree.chart3d.internal.Args;
    040
    041/**
    042 * An event used to signal a change to a {@link Plot3D}.  Any object that
    043 * implements the {@link Plot3DChangeListener} interface can register with a
    044 * plot to receive change notifications.  By default, the {@link Chart3D}
    045 * object will register with the plot it manages to monitor changes to the plot
    046 * and its subcomponents.
    047 * <br><br>
    048 * NOTE: This class is serializable, but the serialization format is subject
    049 * to change in future releases and should not be relied upon for persisting
    050 * instances of this class.
    051 */
    052@SuppressWarnings("serial")
    053public class Plot3DChangeEvent extends EventObject {
    054
    055    /** The plot. */
    056    private final Plot3D plot;
    057
    058    /** Does the plot change require the world to be updated? */
    059    private final boolean requiresWorldUpdate;
    060
    061    /**
    062     * Creates a new event.  The {@code source} of the event can be
    063     * either the plot instance or another event that was received by the
    064     * plot (for example, a {@link Dataset3DChangeEvent}).
    065     *
    066     * @param source  the event source ({@code null} not permitted).
    067     * @param plot  the plot ({@code null} not permitted).
    068     * @param requiresWorldUpdate  a flag that indicates whether or not the
    069     *     world requires updating because of this change.
    070     */
    071    public Plot3DChangeEvent(Object source, Plot3D plot,
    072            boolean requiresWorldUpdate) {
    073        super(source);
    074        Args.nullNotPermitted(plot, "plot");
    075        this.plot = plot;
    076        this.requiresWorldUpdate = requiresWorldUpdate;
    077    }
    078
    079    /**
    080     * Returns the plot from which the event came.
    081     *
    082     * @return The plot (never {@code null}).
    083     */
    084    public Plot3D getPlot() {
    085        return this.plot;
    086    }
    087
    088    /**
    089     * Returns the flag indicating whether or not this change event
    090     * requires the world to be updated/recreated.
    091     *
    092     * @return A boolean.
    093     *
    094     * @since 1.2
    095     */
    096    public boolean requiresWorldUpdate() {
    097        return this.requiresWorldUpdate;
    098    }
    099
    100}